#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long res=0;
    int n,k;
    cin>>n>>k;
    int a[n];
    for(int i=0;i<n;i++){
        long long x;
        cin>>x;
        if(k==1)
            res+=x*(i+1)*(n-i);
        else if(k==0)
            res+=x;
        res%=1000000007;
    }
    cout << res << endl;
    return 0;
}